﻿unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.StdCtrls, Vcl.Grids, Vcl.Imaging.pngimage, Vcl.ExtCtrls, Vcl.Buttons;

type
  TForm41 = class(TForm)
    Label2: TLabel;
    lbSizeInfo: TLabel;
    lbPathInfo: TLabel;
    rbAktFile: TRadioButton;
    rbOther: TRadioButton;
    lbRestore: TListBox;
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    sgFiles: TStringGrid;
    edName: TComboBox;
    bnFind: TButton;
    bnSearchBackFiles: TButton;
    bnRestore: TBitBtn;
    PopRestore: TPopupMenu;
    Eigenschaften1: TMenuItem;
    N1: TMenuItem;
    Dateilschen1: TMenuItem;
    lbBackupPath: TLabel;
    Button1: TButton;
    Label3: TLabel;
    procedure sgFilesDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form41: TForm41;

implementation

{$R *.dfm}

procedure TForm41.Button1Click(Sender: TObject);
begin
  lbRestore.items.Add('Test');
  sgFiles.refresh;
end;

procedure TForm41.sgFilesDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  T: String;  c: TColor;  add: Integer;
begin
  if lbRestore <> NIL then begin
    if lbRestore.items.count = 0 then exit;
  end;

  if ARow = 0 then exit;

  add := 2;
  {$IFDEF MACOS}
  add := 0;
  {$ENDIF}

  with sgFiles.Canvas do begin { Zeichnen auf der Zeichenfläche des Dialogelements, nicht auf dem Formular}
    FillRect(Rect);	{ Rechteck löschen }

    c := sgFiles.canvas.font.color;
    // Datum Uhrzeit
    T := '22.02.2020' + ' ' + '10:12';

    if not (gdselected in state) then begin
      try
        if copy (T, 1, 10) = FormatDateTime ('dd.mm.yyyy', now) then sgFiles.canvas.Font.color := clred;
        if copy (T, 1, 10) = FormatDateTime ('dd.mm.yyyy', now-1) then sgFiles.canvas.Font.color := clBlue;
        if copy (T, 1, 10) = FormatDateTime ('dd.mm.yyyy', now-2) then sgFiles.canvas.Font.color := clfuchsia;
      except
      end;
    end;

    try
      T := FormatDateTime ('ddd', StrToDateTime (T)) + ' ' + T;
    except
      T := T;
    end;

    if ACol = 0 then begin
      TextOut (Rect.Left+2, Rect.Top+add, T);
    end;

    if Acol = 1 then begin
      sgFiles.canvas.font.color := c;

      // Größe
      T := '20000';
      TextOut (Rect.right - (sgFiles.canvas.TextWidth(T)+5), Rect.Top+add, T);
    end;

    if ACol = 2 then begin
      // Dateiname
      T := 'Filename';
      TextOut (Rect.Left+2, Rect.Top+add, T);
    end;

    if ACol = 3 then begin
      // Verzeichnis
      T := 'Path';
      TextOut (Rect.Left+2 , Rect.Top+add, T);
    end;
  end;
end;

end.
